#include "main.h"
#include "knightrider.h"
#include "pattern.h"


static uint8_t *start_pattern;			// point to first pattern
static uint8_t count;				// number of steps
static uint8_t step;				// current step


uint8_t select( uint8_t num )
{
  uint8_t *start_p;
  uint8_t i;

  for( start_p = pattern, i = 0; num; num-- ){
    start_p += i;
    i = *start_p++;				// first entry = length of sample
    if( i == 0 ){				// if exceed number of samples
      start_p = pattern;			// then select first sample
      i = *start_p++;
      break;
    }
  }
  start_pattern = start_p;
  count = i;
  step = 0;
  return num;					// 0 = entry found
}


void run_pattern()
{
  LED_PORT = ~start_pattern[step];
  if( ++step >= count )
    step = 0;
}
